;--------------------------------------------------
;
; Data
;
DATA		SEGMENT WORD PUBLIC
		ASSUME	DS:DATA

EXTRN	Plane1	:	Dword
EXTRN    Ty1        : word;
EXTRN    Tx1        : word;
EXTRN    TDy        : Dword;
EXTRN    TDx        : Dword;
EXTRN    Tx2        : Dword;
EXTRN    TScaleX    : Dword;
EXTRN    TShape     : Dword;
EXTRN    Tscy       : Dword;

EXTRN    WXB        : Dword;
EXTRN    WYB        : Dword;
EXTRN    WX         : word;
EXTRN    WY         : word;

DATA		ENDS


;--------------------------------------------------
;
; Code
;
          .286

CODE 	SEGMENT PUBLIC
		ASSUME	CS:CODE

ScreenWidth              equ  352/4

SEQ_ADDR		          equ	03C4h
SEQ_DATA	    	          equ	03C5h
SEQ_MEMORY_MODE		equ	4
SEQ_04h_C4		     equ	8
SEQ_04h_OE		     equ	4
SEQ_04h_EM		     equ	2


GRAPHC_ADDR		     equ	03CEh
GRAPHC_DATA		     equ	03CFh
GRAPHC_SR		          equ	0
GRAPHC_ENABLE_SR	     equ	1
GRAPHC_DATA_ROTATE	     equ	3
GRAPHC_MODE		     equ	5
GRAPHC_BIT_MASK	     equ	8

SHIFT_REG_2		     equ	040h
READ_MODE_0		     equ	0
READ_MODE_1		     equ	8
WRITE_MODE_0		     equ	0
WRITE_MODE_1		     equ	01
WRITE_MODE_2		     equ	02
WRITE_MODE_3		     equ	03

VIDSEG				equ	0A000h
VRAM                     equ	0A000h
VRAM_LIMIT               equ	01000h


SSTAKEL	macro
			push	bp					; // Fix stack for local variables
			mov	bp,sp
			sub	sp,AUTO_SIZE
          endm

SSTACK  	macro
			push	bp					; // Fix stack for local variables
			mov	bp,sp
		endm

RSTACK	macro
			mov	sp,bp					; // restore stack for exit
			pop	bp
		endm


            .386P

	 
;******************************************************************************
;
;    Draw scaled line on Y!
;
;******************************************************************************
DoLineY   macro  size,NoPixels,t2
          local  count,base,temp,cnt
TmpYB_&t2:
          cnt=NoPixels-1
          count=(size*65536)/NoPixels            ; Make CODE
          base=count*(NoPixels-1)		; Get LAST pixel offset.
          rept  NoPixels
             temp=base/65536
             DB     08Ah,09Ch                    ;mov   bl,ds:[si+(temp*size)]
             DB     LOW  (Temp*size)
             DB     HIGH (Temp*size)
             DB     026H,088h,09Dh		;mov   es:[di+(cnt*320)],bl
             DB     LOW  (cnt*320)
             DB     HIGH (cnt*320)
             base=(base-count)
             cnt=(cnt-1)
          endm
          ret
          endm

DoSpriteY macro size
          local count
             DoLineY  64,1,%1                     ; Loop round make code
             DoLineY  64,2,%2                     ; Loop round make code
             DoLineY  64,3,%3                     ; Loop round make code
             DoLineY  64,4,%4                     ; Loop round make code
             DoLineY  64,5,%5                     ; Loop round make code
             DoLineY  64,6,%6                     ; Loop round make code
             DoLineY  64,7,%7                     ; Loop round make code
             DoLineY  64,8,%8                     ; Loop round make code
             DoLineY  64,9,%9                     ; Loop round make code
             DoLineY  64,10,%10                     ; Loop round make code

             DoLineY  64,11,%11                     ; Loop round make code
             DoLineY  64,12,%12                     ; Loop round make code
             DoLineY  64,13,%13                     ; Loop round make code
             DoLineY  64,14,%14                     ; Loop round make code
             DoLineY  64,15,%15                     ; Loop round make code
             DoLineY  64,16,%16                     ; Loop round make code
             DoLineY  64,17,%17                     ; Loop round make code
             DoLineY  64,18,%18                     ; Loop round make code
             DoLineY  64,19,%19                     ; Loop round make code
             DoLineY  64,20,%20                     ; Loop round make code

             DoLineY  64,21,%21                     ; Loop round make code
             DoLineY  64,22,%22                     ; Loop round make code
             DoLineY  64,23,%23                     ; Loop round make code
             DoLineY  64,24,%24                     ; Loop round make code
             DoLineY  64,25,%25                     ; Loop round make code
             DoLineY  64,26,%26                     ; Loop round make code
             DoLineY  64,27,%27                     ; Loop round make code
             DoLineY  64,28,%28                     ; Loop round make code
             DoLineY  64,29,%29                     ; Loop round make code
             DoLineY  64,30,%30                     ; Loop round make code

             DoLineY  64,31,%31                     ; Loop round make code
             DoLineY  64,32,%32                     ; Loop round make code
             DoLineY  64,33,%33                     ; Loop round make code
             DoLineY  64,34,%34                     ; Loop round make code
             DoLineY  64,35,%35                     ; Loop round make code
             DoLineY  64,36,%36                     ; Loop round make code
             DoLineY  64,37,%37                     ; Loop round make code
             DoLineY  64,38,%38                     ; Loop round make code
             DoLineY  64,39,%39                     ; Loop round make code
             DoLineY  64,40,%40                     ; Loop round make code

             DoLineY  64,41,%41                     ; Loop round make code
             DoLineY  64,42,%42                     ; Loop round make code
             DoLineY  64,43,%43                     ; Loop round make code
             DoLineY  64,44,%44                     ; Loop round make code
             DoLineY  64,45,%45                     ; Loop round make code
             DoLineY  64,46,%46                     ; Loop round make code
             DoLineY  64,47,%47                     ; Loop round make code
             DoLineY  64,48,%48                     ; Loop round make code
             DoLineY  64,49,%49                     ; Loop round make code
             DoLineY  64,50,%50                     ; Loop round make code

             DoLineY  64,51,%51                     ; Loop round make code
             DoLineY  64,52,%52                     ; Loop round make code
             DoLineY  64,53,%53                     ; Loop round make code
             DoLineY  64,54,%54                     ; Loop round make code
             DoLineY  64,55,%55                     ; Loop round make code
             DoLineY  64,56,%56                     ; Loop round make code
             DoLineY  64,57,%57                     ; Loop round make code
             DoLineY  64,58,%58                     ; Loop round make code
             DoLineY  64,59,%59                     ; Loop round make code
             DoLineY  64,60,%60                     ; Loop round make code

             DoLineY  64,61,%61                     ; Loop round make code
             DoLineY  64,62,%62                     ; Loop round make code
             DoLineY  64,63,%63                     ; Loop round make code
             DoLineY  64,64,%64                     ; Loop round make code
             DoLineY  64,65,%65                     ; Loop round make code
             DoLineY  64,66,%66                     ; Loop round make code
             DoLineY  64,67,%67                     ; Loop round make code
             DoLineY  64,68,%68                     ; Loop round make code
             DoLineY  64,69,%69                     ; Loop round make code
             DoLineY  64,70,%70                     ; Loop round make code

             DoLineY  64,71,%71                     ; Loop round make code
             DoLineY  64,72,%72                     ; Loop round make code
             DoLineY  64,73,%73                     ; Loop round make code
             DoLineY  64,74,%74                     ; Loop round make code
             DoLineY  64,75,%75                     ; Loop round make code
             DoLineY  64,76,%76                     ; Loop round make code
             DoLineY  64,77,%77                     ; Loop round make code
             DoLineY  64,78,%78                     ; Loop round make code
             DoLineY  64,79,%79                     ; Loop round make code
             DoLineY  64,80,%80                     ; Loop round make code

             DoLineY  64,81,%81                     ; Loop round make code
             DoLineY  64,82,%82                     ; Loop round make code
             DoLineY  64,83,%83                     ; Loop round make code
             DoLineY  64,84,%84                     ; Loop round make code
             DoLineY  64,85,%85                     ; Loop round make code
             DoLineY  64,86,%86                     ; Loop round make code
             DoLineY  64,87,%87                     ; Loop round make code
             DoLineY  64,88,%88                     ; Loop round make code
             DoLineY  64,89,%89                     ; Loop round make code
             DoLineY  64,90,%90                     ; Loop round make code

             DoLineY  64,91,%91                     ; Loop round make code
             DoLineY  64,92,%92                     ; Loop round make code
             DoLineY  64,93,%93                     ; Loop round make code
             DoLineY  64,94,%94                     ; Loop round make code
             DoLineY  64,95,%95                     ; Loop round make code
             DoLineY  64,96,%96                     ; Loop round make code
             DoLineY  64,97,%97                     ; Loop round make code
             DoLineY  64,98,%98                     ; Loop round make code
             DoLineY  64,99,%99                     ; Loop round make code
             DoLineY  64,100,%100                     ; Loop round make code
;
;             DoLineY  64,101,%101                     ; Loop round make code
;             DoLineY  64,102,%102                     ; Loop round make code
;             DoLineY  64,103,%103                     ; Loop round make code
;             DoLineY  64,104,%104                     ; Loop round make code
;             DoLineY  64,105,%105                     ; Loop round make code
;             DoLineY  64,106,%106                     ; Loop round make code
;             DoLineY  64,107,%107                     ; Loop round make code
;             DoLineY  64,108,%108                     ; Loop round make code
;             DoLineY  64,109,%109                     ; Loop round make code
;             DoLineY  64,110,%110                     ; Loop round make code
;

         endm

;******************************************************************************
;
; Actual code bits, lines then tables
;
;******************************************************************************
ScaleLinesY proc
           public   ScaleLinesY

           DoSpriteY 64                            ; actually gen code.

ScaleLinesY Endp

ScaleLineY proc
           public  ScaleLineY                 ; actually gen table.

           dd      TmpYB_1
           dd      TmpYB_2
           dd      TmpYB_3
           dd      TmpYB_4
           dd      TmpYB_5
           dd      TmpYB_6
           dd      TmpYB_7
           dd      TmpYB_8
           dd      TmpYB_9
           dd      TmpYB_10

           dd      TmpYB_11
           dd      TmpYB_12
           dd      TmpYB_13
           dd      TmpYB_14
           dd      TmpYB_15
           dd      TmpYB_16
           dd      TmpYB_17
           dd      TmpYB_18
           dd      TmpYB_19
           dd      TmpYB_20

           dd      TmpYB_21
           dd      TmpYB_22
           dd      TmpYB_23
           dd      TmpYB_24
           dd      TmpYB_25
           dd      TmpYB_26
           dd      TmpYB_27
           dd      TmpYB_28
           dd      TmpYB_29
           dd      TmpYB_30

           dd      TmpYB_31
           dd      TmpYB_32
           dd      TmpYB_33
           dd      TmpYB_34
           dd      TmpYB_35
           dd      TmpYB_36
           dd      TmpYB_37
           dd      TmpYB_38
           dd      TmpYB_39
           dd      TmpYB_40

           dd      TmpYB_41
           dd      TmpYB_42
           dd      TmpYB_43
           dd      TmpYB_44
           dd      TmpYB_45
           dd      TmpYB_46
           dd      TmpYB_47
           dd      TmpYB_48
           dd      TmpYB_49
           dd      TmpYB_50

           dd      TmpYB_51
           dd      TmpYB_52
           dd      TmpYB_53
           dd      TmpYB_54
           dd      TmpYB_55
           dd      TmpYB_56
           dd      TmpYB_57
           dd      TmpYB_58
           dd      TmpYB_59
           dd      TmpYB_60

           dd      TmpYB_61
           dd      TmpYB_62
           dd      TmpYB_63
           dd      TmpYB_64
           dd      TmpYB_65
           dd      TmpYB_66
           dd      TmpYB_67
           dd      TmpYB_68
           dd      TmpYB_69
           dd      TmpYB_70

           dd      TmpYB_71
           dd      TmpYB_72
           dd      TmpYB_73
           dd      TmpYB_74
           dd      TmpYB_75
           dd      TmpYB_76
           dd      TmpYB_77
           dd      TmpYB_78
           dd      TmpYB_79
           dd      TmpYB_80

           dd      TmpYB_81
           dd      TmpYB_82
           dd      TmpYB_83
           dd      TmpYB_84
           dd      TmpYB_85
           dd      TmpYB_86
           dd      TmpYB_87
           dd      TmpYB_88
           dd      TmpYB_89
           dd      TmpYB_90

           dd      TmpYB_91
           dd      TmpYB_92
           dd      TmpYB_93
           dd      TmpYB_94
           dd      TmpYB_95
           dd      TmpYB_96
           dd      TmpYB_97
           dd      TmpYB_98
           dd      TmpYB_99
           dd      TmpYB_100
;
;           dd      TmpY_101
;           dd      TmpY_102
;           dd      TmpY_103
;           dd      TmpY_104
;           dd      TmpY_105
;           dd      TmpY_106
;           dd      TmpY_107
;           dd      TmpY_108
;           dd      TmpY_109
;           dd      TmpY_110

           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
           dd      TmpYB_100
	dd      TmpYB_100

ScaleLineY endp


;******************************************************************************
;
;    Draw a scaled sprite. if over 64 pixels wide - ignore.
;
;         Tx1,Ty1    : word;
;         TDy        : word;
;         TDx        : Dword;
;         Tx2        : Dword;
;         TScaleX    : Dword;
;         TShape     : Dword;
;
;     xx:=(x1*$10000)+$8000;                 { get X start cord }
;     yy:=(y1*$10000)+$8000;                 { get Y start cord }
;     x:=$8000;                      { texture Y half way through pixel }
;     repeat
;           y:=0;
;           index:=(xx shr 16)+((yy shr 16)*320);
;           tindex:=(x shr 16);
;           repeat
;                 Screen^[index]:= shape^[((y shr 10) and $ffffffc0)+tindex];
;
;                 inc (y,tScaleX);            { do scale on X        }
;                 inc (index,320);            { next pixel on screen }
;           until (y>$400000);
;           inc (x,scy);
;           inc (xx,Dx1);
;           inc (yy,dy1);
;           t2:=t2-scaleX;
;           tScaleX:=$400000 div ((t2-yy+$10000) shr 16);
;     until (x>$400000);*)
;
;******************************************************************************


DrawaScaledBlockClippedY  proc far
                  public DSBClippedYBot

          EVENDATA
cnt       =    320
_Table:   dw   0
          rept      200
          dw  cnt
cnt       = cnt+320
          endm


_y2          dd    0
_xx          dd    0
ty           dd    0
_Dx          dd    0
_Dy          dd    0
_tScy        dd    0
_ScaleX      dd    0
_x2          dd    0
_tt          dd    0

	EVENDATA
cnt       =    0
SkipTable:
          rept      63
          dw  cnt
cnt       = cnt+9
          endm
          rept 200
          dw   64*9
          endm
_Ybase       dw    0
_YClip       dw    0
_YSize       dw    0
_Yadd        dw    0
_TCX         dd    0
_WXB	  dd    0
_WYB	  dd    0
_WY	  dw    0

DSBClippedYBot:
          SSTack
 		push	di
          push	es
          push	ds


          mov  eax,wxb
          mov  _WXB,eax
          mov  eax,wyb
          mov  _WYB,eax
          mov  ax,wy
          dec  ax
          mov  _WY,ax
          mov  eax,TscaleX    ; Copy Paramaters over
          mov  _ScaleX,eax
          mov  eax,Tscy       ; Copy Paramaters over
          mov  _tScy,eax
          mov  eax,Tdx        ; Copy Paramaters over
          mov  _Dx,eax
          mov  eax,Tdy
          mov  _Dy,eax
          mov  eax,Tx2
          mov  _y2,eax        ; Y axis this time!

          mov  cx,Tx1         ; scale x cord up!
          shl  ecx,16
          mov  ax,Ty1         ; scale Y cord up!
          shl  eax,16
          mov  edx,08000h

          les  di,Plane1
          lds  si,TShape      ; get graphic address

@SLoop2:
          push si
          push di

          mov  ebx,eax         ; work out NEW X,Y pos on screen.
          shr  ebx,16
          add  bx,bx
          add  di,word ptr _Table[bx]    ;[ebx*2] is better
          shld ebx,ecx,16      ; Get X cord and add on.
          add  di,bx

          cmp  ecx,_WXB        ; 320*010000h
          jae  @SkipY2


          mov  ebx,edx          ; work out new start in texture
          shr  ebx,16           ; (new start pixel)
          add  si,bx

          mov  _Yclip,0
          mov  _Ysize,0
          mov  ebx,_y2          ; Work out address for line printing Jump table
          cmp  ebx,_WYB         ; 200*65536    ; ie get the CLIP size
          jl   @ok
          shr  ebx,16
          sub  bx,_WY	         ;199	         ; Sub off Screen width - get how much is OVER
          mov  _Ysize,bx
          add  bx,bx            ; Get CLIP size
          mov  bx,word ptr SkipTable[bx]
          mov  _Yclip,bx

@ok:      mov  ebx,_y2
          sub  ebx,eax         ; Get WIDTH to print!
          shr  ebx,16          ; shr 16, *4
          cmp  bx,_Ysize
          jl   @SkipY2

          add  bx,bx
          add  bx,bx
          add  bx,offset ScaleLineY
          mov  bx,cs:[bx]
          add  bx,_Yclip
          call bx

@SkipY2:
          mov  ebx,_ScaleX    ; Line Draw on Y (right side)
          sub  _Y2,ebx
          add  eax,_Dy
          add  ecx,_Dx        ; Line draw on X,Y (left side)
          add  edx,_tScy      ; Scale Texture on X axis
          mov  _xx,edx

          pop  di
          pop  si
          cmp  edx,0400000h
          jle  @SLoop2




@TExitY2:	pop	ds
          pop	es
          pop	di

          RSTACK
          ret

DrawaScaledBlockClippedY  endp
	 
	 

	 
	 
	 
	 
	 
	 
CODE	ENDS
     END


